package com.caimei365.manager.dao;


import com.caimei365.manager.entity.SysMenu;
import com.caimei365.manager.entity.SysUser;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * Description
 *
 * @author : Charles
 * @date : 2021/12/2
 */
@Mapper
public interface SysUserDao {

    /**
     * 根据用户名称查找用户
     */
    SysUser findByUsername(String username);

    /**
     * 新增系统用户
     */
    void insertSysUser(SysUser sysUser);

    /**
     * 新增用户角色关系表
     */
    void insertUserRoleRelation(Integer userId, Integer roleId);

    /**
     * 获取用户角色名称列表
     */
    List<String> getRoleList(Integer userId);

    /**
     * 获取用户角色Id列表
     */
    List<Integer> getRoleIdsByUserId(String username);

    /**
     * 根据角色Ids获取菜单列表
     */
    List<SysMenu> getMenusByRoleIds(@Param("roleIds") List<Integer> roleIds);

    /**
     * 获取菜单列表
     * @param parentId 父级菜单Id
     * @param level    菜单层级
     * @param status   状态：0启用，1停用
     */
    List<SysMenu> getMenuList(Integer parentId, Integer level, Integer status);

    /**
     * 根据ID获取菜单
     */
    SysMenu getMenu(Integer id);

    /**
     * 根据ID更新菜单
     */
    void updateMenu(SysMenu menu);

    /**
     * 根据ID删除菜单
     */
    void deleteMenu(Integer id);
}
