package com.caimei365.manager.service;


import com.caimei365.manager.entity.PaginationVo;
import com.caimei365.manager.entity.ResponseJson;
import com.caimei365.manager.entity.SysMenu;
import com.caimei365.manager.entity.SysUser;

import java.util.List;

/**
 * Description
 *
 * @author : Charles
 * @date : 2021/12/2
 */

public interface SysUserService {

    /**
     * 获取用户信息
     */
    ResponseJson<SysUser> getInfoByUsername(String username);

    /**
     * 获取菜单列表
     * @param parentId 父级菜单Id
     * @param level    菜单层级
     * @param status   状态：0启用，1停用
     * @param pageNum  页码
     * @param pageSize 每页大小
     */
    ResponseJson<PaginationVo<SysMenu>> getMenuList(Integer parentId, Integer level, Integer status, int pageNum, int pageSize);

    /**
     * 根据ID获取菜单
     */
    ResponseJson<SysMenu> getMenu(Integer id);

    /**
     * 根据ID更新菜单
     */
    ResponseJson<Void> updateMenu(Integer id, SysMenu menu);

    /**
     * 根据ID删除菜单
     */
    ResponseJson<Void> deleteMenu(Integer id);


//    /**
//     * 获取用户可访问菜单
//     */
//    ResponseJson<List<SysMenu>> menuList(String username);
    /**
     * 退出登录
     */
    ResponseJson<Void> logout(String token);
    /**
     * 注册接口
     */
    ResponseJson<SysUser> register(SysUser sysUser);


}
